*
* NB: THERMOS FUNCTION IS ONLY 20 LINES AT THE END OF THIS FILE
*
* The following is an example of 4 processes of differing lengths.
* 5 calls to 'thermos' provide scale movement whilst, 4 calls to 
* 'thermos' provide an animation during each process.
*
* Note that these calls could equally be:
*	SCAN FOR thermos()
*	REPORT .... FOR thermos()
*	SELECT .... FOR thermos()
*	REPLACE ... FOR thermos()
*	DO WHILE ... AND thermos()
*  ... or any other scopable FoxPro command
*
* Alternatively you could calculate full scale & increment 
* a counter to display a moving thermometer ie. 
*
*	COUNT TO n FOR [report conditions]
*	counter = 1
*	REPORT ... FOR [report conditions] AND progress(100/n)
*
* where:
*
* FUNCTION progress
*	counter = counter + 1
*	DO thermos WITH (100/n) * counter	
* RETURN .T.
*
* Example:
SET STATUS BAR ON
oldmsg = SET('MESSAGE TO',1)
WAIT 'Example #1: Any key to begin ...' WINDOW
FOR x = 1 TO 100
	WAIT 'Example #1' WINDOW TIMEOUT 0.001
	=thermos(x)
ENDFOR
WAIT 'Example #2: Any key to begin ...' WINDOW
WAIT 'Example #2' WINDOW NOWAIT
DO thermos WITH 0
FOR x = 1 TO 100
	=thermos()
ENDFOR
DO thermos WITH 20
FOR x = 1 TO 400
	=thermos()
ENDFOR
DO thermos WITH 40
FOR x = 1 TO 200
	=thermos()
ENDFOR
DO thermos WITH 60
FOR x = 1 TO 400
	=thermos()
ENDFOR
DO thermos WITH 100
WAIT 'No bad eh ?' WINDOW 
SET MESSAGE TO oldmsg

*:********************************************************
* Function to display a thermometer style progress indicator in the status bar
* Author - Brian M Smith 100345,355
* Last Updated - 25/11/94
* Parameters - m.perc (percentage to show - none to rotate)
*:********************************************************
FUNCTION thermos
PARAMETER perc
PRIVATE ALL
	IF TYPE('perc') = 'N'
		progress = INT(perc/2)
		SET MESSAGE TO 'Progress: ' + REPLICATE(CHR(127),progress) + ;
			REPLICATE('-',50-(progress)) + ' ' + ALLTRIM(STR(INT(perc))) + '%'
	ELSE
		thismsg = SET('MESSAGE TO',1)
		oldmsg = LEFT(thismsg,LEN(thismsg)-1)
		DO CASE
			CASE RIGHT(m.thismsg,1) = '+'
				SET MESSAGE TO m.oldmsg + CHR(215)
			CASE RIGHT(m.thismsg,1) = CHR(215)
				SET MESSAGE TO m.oldmsg + '+'
		OTHERWISE
			SET MESSAGE TO m.thismsg + ' +'	
		ENDCASE	
	ENDIF	
RETURN .T.
